#Charles Tierney, Math198 Fall 2015
#Script that shows a rotating wind turbine
#With winglets.
#Tuesday, 12/13/15

from visual import *
from math import *

scene1 = display(title="Turbines", width = 500, height = 500, center = (0,0,0), background = (0,0,1))


t = 0

world_fr=frame()
blade_fr1=frame(frame=world_fr)
blade_fr2=frame(frame=world_fr)
blade_fr3=frame(frame=world_fr)
winglet_fr1=frame(frame=blade_fr1)
winglet_fr2=frame(frame=blade_fr2)
winglet_fr3=frame(frame=blade_fr3)

blade_fr1.axis=(1,0,0)
blade_fr2.axis=(cos(2*3.14/3), sin(2*3.14/3), 0)
blade_fr3.axis=(cos(4*3.14/3), sin(4*3.14/3), 0)
blade_fr1.pos=(.75,1,0)
blade_fr2.pos=(.75*cos(2*3.14/3), .75*sin(2*3.14/3)+1, 0)
blade_fr3.pos=(.75*cos(4*3.14/3), .75*sin(4*3.14/3)+1, 0)
winglet_fr1.pos=(.75,0,0)
winglet_fr2.pos=(.75,0,0)
winglet_fr3.pos=(.75,0,0)

tower = box(frame=world_fr, pos=(0,-.5,0), length=.5, height=3, width=.5)
blade1 = box(frame=blade_fr1, pos=(0,0,.375), length=1.5, height=.5, width=.25)
blade2 = box(frame=blade_fr2, pos=(0,0,.375), length=1.5, height=.5, width=.25)
blade3 = box(frame=blade_fr3, pos=(0,0,.375), length=1.5, height=.5, width=.25)
rotor_base = cylinder(frame=world_fr, pos=(0,1,-.25), axis =(0,0,.5), radius = .25)

winglet1 = box(frame=winglet_fr1, pos=(-.125,0,.625), length = .25, height=.5, width=.25)
winglet2 = box(frame=winglet_fr2, pos=(-.125,0,.625), length = .25, height=.5, width=.25)
winglet3 = box(frame=winglet_fr3, pos=(-.125,0,.625), length = .25, height=.5, width=.25)

number = 100
wake1 = curve(pos=blade_fr1.frame_to_world(winglet_fr1.frame_to_world(winglet1.pos)), radius=.1)
wake2 = curve(pos=blade_fr2.frame_to_world(winglet_fr2.frame_to_world(winglet2.pos)), radius=.100)
wake3 = curve(pos=blade_fr3.frame_to_world(winglet_fr3.frame_to_world(winglet3.pos)), radius=.100)
increment = .007

while True:
	rate(100)
	blade_fr1.rotate(angle=4*increment, axis=(0,0,1), origin=(0,1,0))
	blade_fr2.rotate(angle=4*increment, axis=(0,0,1), origin=(0,1,0))
	blade_fr3.rotate(angle=4*increment, axis=(0,0,1), origin=(0,1,0))
	blade_fr1.z+=increment
	blade_fr2.z+=increment
	blade_fr3.z+=increment
	tower.pos.z+=increment
	rotor_base.pos.z+=increment
	scene1.center.z+=increment
	new_pos1=blade_fr1.frame_to_world(winglet_fr1.frame_to_world(winglet1.pos))
	new_pos2=blade_fr2.frame_to_world(winglet_fr2.frame_to_world(winglet2.pos))
	new_pos3=blade_fr3.frame_to_world(winglet_fr3.frame_to_world(winglet3.pos))
	wake1.append(pos=(new_pos1.x, new_pos1.y, new_pos1.z+increment), retain=1000)
	wake2.append(pos=(new_pos2.x, new_pos2.y, new_pos2.z+increment), retain=1000)
	wake3.append(pos=(new_pos3.x, new_pos3.y, new_pos3.z+increment), retain=1000)
	if scene1.kb.keys:
		k = scene1.kb.getkey()
		if k == 'a' and increment < 6.28:
			increment+=.0001
		elif k == 'a' and increment >= 6.28:
			pass
		elif k == 'd' and increment > 0:
			increment-=.0001
		elif k == 'd' and increment <= 0:
			pass